#include <string.h>

#include "bsp.h"
#include "driver/gpio.h"
#include "esp_err.h"
#include "esp_log.h"
#include "eyes.h"
#include "freertos/task.h"
#include "i2c_drv.h"
#include "ibat.h"
#include "images.h"
#include "sdkconfig.h"  // generated by "make menuconfig"
#include "sensors.h"
#include "tm_oled.h"

static const char *TAG = "OLED";

// OLED screen handles
static oled_context_t *left;
static oled_context_t *right;

void badge_turnOffOLED() {
	OLED_DisplayOff(left);
	OLED_DisplayOff(right);
}

void badge_turnOnOLED() {
	OLED_DisplayOn(left);
	OLED_DisplayOn(right);
}

void taskOLED(void *pvParameters) {
	i2c_drv_t *i2c_drv = (i2c_drv_t *)pvParameters;

	left = malloc(sizeof(oled_context_t));
	if (left == NULL) {
		ESP_ERROR_CHECK(ESP_ERR_NO_MEM);
	}
	left->display_buf = NULL,
	left->i2c_drv = i2c_drv;
	left->i2c_addr = OLED_I2C_ADDR_2;

	right = malloc(sizeof(oled_context_t));
	if (right == NULL) {
		ESP_ERROR_CHECK(ESP_ERR_NO_MEM);
	}
	right->display_buf = NULL,
	right->i2c_drv = i2c_drv;
	right->i2c_addr = OLED_I2C_ADDR_1;

	ESP_LOGI(TAG, "Init left display");
	OLED_Init(left);
	ESP_LOGI(TAG, "Init right display");
	OLED_Init(right);
	OLED_DrawBuffer(left, 34, 2, 60, 60, (uint8_t *)tm_logo_new, false, false);
	OLED_DrawBuffer(right, 34, 2, 60, 60, (uint8_t *)tm_logo_new, false, false);
	OLED_UpdateScreen(left);
	OLED_UpdateScreen(right);
	vTaskDelay(1000 / portTICK_RATE_MS);

	Eyes_Init(left, right, input_chip_right);
	Eyes_Init(left, right, input_left_dpad_center);
	Eyes_Init(left, right, input_right_dpad_center);

	//	 uint32_t i = 10;
	//	 uint32_t xLastWakeTime = xTaskGetTickCount() * portTICK_RATE_MS;
	//	 while(i--) {
	//	 	Eyes_StateOpened();
	//	 	Eyes_StateBrow();
	//	 	Eyes_StateBrowLow();
	//	 	Eyes_StateClosedHalf();
	//	 	Eyes_StateClosedLow();
	//	 	Eyes_StateClosedHalf();
	//	 	Eyes_StateBrowLow();
	//	 	Eyes_StateBrow();
	//	 }
	//	 xLastWakeTime = xTaskGetTickCount() * portTICK_RATE_MS - xLastWakeTime;
	//	 ESP_LOGI(TAG, "10 iterations: %u ms", xLastWakeTime);

	Eyes_Sleep();
	Eyes_Wake();
	Eyes_Blink();
	Eyes_Sad();
	Eyes_Blink();
	Eyes_Angry();
	Eyes_Blink();
	Eyes_Wonder();
	Eyes_Blink();
	Eyes_Dummy();
	OLED_FillScreen(left, Black);
	OLED_FillScreen(right, Black);

	sensors_data_t s;

	while (1) {
		//		 Eyes_Blink();

		sensors_getValues(&s);
		OLED_SetCursor(left, 2, 2);
		OLED_SetCursor(right, 2, 2);
		OLED_Printf(right, "H: %2.0f %%\nt: %0.1f\nIAQ: %3.1f\nP: %6.0f\n", s.humidity, s.temperature, s.iaq, s.pressure);
		OLED_Printf(right, "VBat: %d mV\n", ibat_get_mV(bsp_config.pins.vbat));

		OLED_Printf(left, "H: %2.0f %%\nt: %0.1f\nIAQ: %3.1f\nP: %6.0f\n", s.humidity, s.temperature, s.iaq, s.pressure);
		OLED_Printf(left, "VBat: %d mV\n", ibat_get_mV(bsp_config.pins.vbat));

		OLED_UpdateScreen(left);
		OLED_UpdateScreen(right);
		vTaskDelay(10);
	}
}